package org.zipcoder.store;

import java.util.*;

public class MyHashMap implements MyMap{
    // final field that doesn't change for any object
    private static final int BUCKET_SIZE = 15;

    // instance field that can only be set once. It is different for every Object
    private final List<Entry>[] entries;

    public MyHashMap(){
        entries = new List[BUCKET_SIZE];

        for(int i = 0; i < BUCKET_SIZE; i++) {
            entries[i] = new ArrayList<>();
        }
    }

    @Override
    public int size() {
        int counter = 0;
        for(List<Entry> list: entries){
            counter += list.size();
        }
        return counter;
    }

    @Override
    public boolean isEmptry() {
        if(size()==0){
            return true;
        } return false;
    }

    @Override
    public Cart get(User key) {
        Cart cart = null;
        for(Entry entry: entries[bucketIndex(key)]){
            if(entry.getKey().equals(key)){
                cart = entry.getValue();
            }
        }
        return cart;
    }

    @Override
    public void put(User key, Cart value) {
        entries[bucketIndex(key)].add(new Entry(key,value));
    }

    @Override
    public List<User> getKeys() {
        List<User> keys = new ArrayList<>();
        for(List<Entry> list : entries){
            for (Entry entry : list) {
                keys.add(entry.getKey());
            }
        }
        return keys;
    }

    @Override
    public List<Cart> getValues() {
        List<Cart> values = new ArrayList<>();
        for(List<Entry> list : entries){
            for (Entry entry : list) {
                values.add(entry.getValue());
            }
        }
        return values;
    }

    @Override
    public Cart remove(User key) {
        Cart cart = get(key);
        for(Entry entry: entries[bucketIndex(key)]){
            if(entry.getKey().equals(key)){
                entries[bucketIndex(key)].remove(entry);
                break;
            }
        }
        return cart;
    }

    private int bucketIndex(User key){
        return Math.abs(key.hashCode()) % entries.length;
    }
}
